document { "ggnone",
     TT "ggnone", " -- gbengine command string.",
     PARA,
     "arguments: ",
     PARA,
     ""
     }
document { "ggEZZ",
     TT "ggEZZ", " -- gbengine command string.",
     PARA,
     "arguments: . >> EPolynomialRing",
     PARA,
     "Yields the ring ZZ, using the new arithmetic."
     }
document { "ggEcharp",
     TT "ggEcharp", " -- gbengine command string.",
     PARA,
     "arguments: p:int >> EPolynomialRing",
     PARA,
     "Yields the ring ZZ/p, using the new arithmetic.  p must be a positive integer, possibly not prime.  Currently, it is restricted to be less than 2^16-1."
     }
document { "ggadd",
     TT "ggadd", " -- gbengine command string.",
     PARA,
     "arguments: f g >> f+g",
     PARA,
     "Add f and g. [type f, type g] = [vector,vector], [freemodule,freemodule], [matrix,matrix], [monideal,monideal], [ringelem,ringelem].  The sum of two free modules is their direct sum."
     }
document { "ggaddress",
     TT "ggaddress", " -- gbengine command string.",
     PARA,
     "arguments: object >> int",
     PARA,
     "Replace the object with an integer handle.  A reference count is increased, and so each such call must be matched with a call to ggforget."
     }
document { "ggautoreduce",
     TT "ggautoreduce", " -- gbengine command string.",
     PARA,
     "arguments: m:matrix >> matrix",
     PARA,
     "Given a matrix, whose lead terms are not divisible by one another, form the matrix whose i th column is the normal form of the i th column of m, w.r.t. the other columns of m."
     }
document { "ggbasisElement",
     TT "ggbasisElement", " -- gbengine command string.",
     PARA,
     "arguments: F:EFreeModule x:int >> EVector",
     PARA,
     "Create the vector F_x, if x is in the range 0 <= x < rank(F), and return zero otherwise."
     }
document { "ggbetti",
     TT "ggbetti", " -- gbengine command string.",
     PARA,
     "arguments: res_comp >> intarray",
     PARA,
     "Return an intarray in the same format as in 'ggpairs' describing the known minimal betti numbers of the resolution, as so far computed.  These numbers represent minimal bounds on the actual betti numbers."
     }
document { "ggbinomialGB",
     TT "ggbinomialGB", " -- gbengine command string.",
     PARA,
     "arguments: R:ring >> binomialGB_comp",
     PARA,
     "Create a new GB computation for (possibly inhomogeneous) binomial ideals.  No syzygies are computed using this type of computation.  Add generators using ggbinomialGBaddgens, change the ring (enlarge it) using ggbinomialGBenlarge, perform computations using ggcalc, obtain results using gggetmingens, gggetgb, gggetsubring, gggetsubringGB."
     }
document { "ggbinomialGBaddgens",
     TT "ggbinomialGBaddgens", " -- gbengine command string.",
     PARA,
     "arguments: g:binomialGB_comp m:matrix >> .",
     PARA,
     "If 'm' is a one row matrix having the same base ring as 'g', then add the entries of 'm' to the binomial ideal.  If 'm' is an n by m matrix of integers, where n is less than or equal to the number of variables of the base ring of 'g', then the columns are considered as binomials, and are added to the binomial ideal.  It is valid to add generators of lower degree than what has already been computed."
     }
document { "ggbinomialGBenlarge",
     TT "ggbinomialGBenlarge", " -- gbengine command string.",
     PARA,
     "arguments: Enlarges the base ring of 'g' to be 'R'.  The ring, its homogenity, and its term order should be consistent with the old values: The Groebner basis of the binomial ideal should not change.",
     PARA,
     ""
     }
document { "ggborel",
     TT "ggborel", " -- gbengine command string.",
     PARA,
     "arguments: mi:monideal >> monideal",
     PARA,
     "Yield the smallest borel fixed monomial ideal containing 'mi'."
     }
document { "ggcalc",
     TT "ggcalc", " -- gbengine command string.",
     PARA,
     "arguments: computation >> int",
     PARA,
     "Continue the computation on the stack until it is done, or until an interrupt occurs.  A return value of "
     }
document { "ggcharacteristic",
     TT "ggcharacteristic", " -- gbengine command string.",
     PARA,
     "arguments: K:ECoefficientRing >> int",
     PARA,
     "Returns the characteristic of the ring K."
     }
document { "ggcharp",
     TT "ggcharp", " -- gbengine command string.",
     PARA,
     "arguments: int >> ring",
     PARA,
     "Create the prime field with the given characteristic."
     }
document { "ggcodim",
     TT "ggcodim", " -- gbengine command string.",
     PARA,
     "arguments: monideal >> int",
     PARA,
     "Yields the codimension of the given monomial ideal."
     }
document { "ggcoeffs",
     TT "ggcoeffs", " -- gbengine command string.",
     PARA,
     "arguments: m:matrix vars:intarray >> coeffs:matrix monoms:matrix OR m:matrix >> coeffs:matrix monoms:matrix",
     PARA,
     "Given an integer array 'vars' containing variable numbers from 0..numvars ring m-1, find the monomials in these variables, and their coefficients, placing these in the matrices 'coeffs' and 'monoms'.  For the second version: Let x_i be the smallest index variable that occurs in the 'j' th column of 'm'. Then the j th column of coeffs contains the (vector) coefficient of the highest power of this variable, and the j th element of monoms is x_i^n, if n is this highest power."
     }
document { "ggColumn2by2",
     TT "ggColumn2by2", " -- gbengine command string.",
     PARA,
     "arguments: a1:RingElement a2:RingElement b1:RingElement b2:RingElement m:SparseMutableMatrix c1:int c2:int >> .",
     PARA,
     "Modifies columns 'c1' and 'c2' of matrix 'm' as follows: column r1 is replaced with a1*(column c1)+a2*(column c2), and column c2 is replaced with b1*(column c1)+b2*(column c2).  The assignment to columns c1,c2 are performed simultaneously."
     }
document { "ggColumnAddMultiple",
     TT "ggColumnAddMultiple", " -- gbengine command string.",
     PARA,
     "arguments: m:SparseMutableMatrix c1:int a:RingElement c:int >> .",
     PARA,
     "Destructively set m[column c] = m[column c] + a * m[column c1]."
     }
document { "ggColumnInterchange",
     TT "ggColumnInterchange", " -- gbengine command string.",
     PARA,
     "arguments: m:SparseMutableMatrix c1:int c2:int >> .",
     PARA,
     "Destructively interchange the two given columns of 'm'. "
     }
document { "ggColumnScale",
     TT "ggColumnScale", " -- gbengine command string.",
     PARA,
     "arguments: m:SparseMutableMatrix c:int a:RingElement >> .",
     PARA,
     "Destructively set m[column c] = a * m[column c]."
     }
document { "ggcompare",
     TT "ggcompare", " -- gbengine command string.",
     PARA,
     "arguments: a:monomial b:monomial >> int",
     PARA,
     "Place -1,0,1, onto the stack, when a<b,a==b, and a>b, respectively."
     }
document { "ggconcat",
     TT "ggconcat", " -- gbengine command string.",
     PARA,
     "arguments: matrix_1 .. matrix_n n:int >> matrix",
     PARA,
     "Concatenate the columns of all of these matrices together, forming a new matrix.  None of these matrices is itself modified (different behavior from Macaulay).  WARNING: the matrix is set to have the row degrees of the first matrix.  If any other matrix has more rows, there will be trouble.  Additionally, if the row degrees are not the same, then the column degrees will be screwed up as well."
     }
document { "ggcopy",
     TT "ggcopy", " -- gbengine command string.",
     PARA,
     "arguments: elem >> elem",
     PARA,
     "Make a shiny new copy of the item on the top of the stack."
     }
document { "ggcontract",
     TT "ggcontract", " -- gbengine command string.",
     PARA,
     "arguments: m:matrix n:matrix >> matrix",
     PARA,
     "Yields the matrix having the same shape as the tensor product, whose individual entries are the result of contracting (i.e. differentiate without using bringing down coefficients) entries of n by entries of m."
     }
document { "ggdeclarefield",
     TT "ggdeclarefield", " -- gbengine command string.",
     PARA,
     "arguments: R:Ring >> .",
     PARA,
     "Informs the engine that R is (probably) a field.  If at some point a zero divisor is found, then the engine flags that R is not a field, raises an error, and keeps a zero divisor stashed in the ring.  gggetzerodivisor retrieves this ring element."
     }
document { "ggdegree",
     TT "ggdegree", " -- gbengine command string.",
     PARA,
     "arguments: f:ringelem >> intarray;  OR  monomial >> int",
     PARA,
     "(First form) Place the (multi-)degree of the lead term of f onto the stack. (Second form) Yields the sum of the exponents of the given monomial."
     }
document { "ggdenominator",
     TT "ggdenominator", " -- gbengine command string.",
     PARA,
     "arguments: f:ringelem >> g:ringelem",
     PARA,
     "If f = g/h is an element of a fraction field frac(R), return the denominator h in R."
     }
document { "ggderef",
     TT "ggderef", " -- gbengine command string.",
     PARA,
     "arguments: int >> object",
     PARA,
     "Replace the integer handle with its corresponding object."
     }
document { "ggdets",
     TT "ggdets", " -- gbengine command string.",
     PARA,
     "arguments: m:matrix p:int >> determinant computation",
     PARA,
     "Create a computation which will yield the p by p minors of the matrix m."
     }
document { "ggdiff",
     TT "ggdiff", " -- gbengine command string.",
     PARA,
     "arguments: m:matrix n:matrix >> matrix",
     PARA,
     "Yields the matrix having the same shape as the tensor product, whose individual entries are the result of differentiating entries of n by entries of m."
     }
document { "ggdim",
     TT "ggdim", " -- gbengine command string.",
     PARA,
     "arguments: f:ring_elem >> ring_elem",
     PARA,
     "Given a ring element, f, in a schur ring, replace each monomial with the dimension of the irreducible GL(n) representation having that monomial as highest weight, and return the resulting sum. (f is not modified)."
     }
document { "ggdirectsum",
     TT "ggdirectsum", " -- gbengine command string.",
     PARA,
     "arguments: Yields the direct sum (i.e. block sum) of the two matrices.",
     PARA,
     ""
     }
document { "ggdiv",
     TT "ggdiv", " -- gbengine command string.",
     PARA,
     "arguments: a:ringelem b:ringelem >> ringelem",
     PARA,
     "Find a/b in the ring of a, b, if division is defined over this ring."
     }
document { "ggdivides",
     TT "ggdivides", " -- gbengine command string.",
     PARA,
     "arguments: a:monomial b:monomial >> int",
     PARA,
     "Place 0, (or 1) onto the stack when a doesn't divide (does divide) b."
     }
document { "ggdivmod",
     TT "ggdivmod", " -- gbengine command string.",
     PARA,
     "arguments: a:ringelem b:ringelem >> d:ringelem m:ringelem",
     PARA,
     "Find d = a/b and m = (a mod b) in the ring of a, b, if division is defined over this ring."
     }
document { "ggDOUBLE",
     TT "ggDOUBLE", " -- gbengine command string.",
     PARA,
     "arguments: >> RingElement",
     PARA,
     "Read a double precision floating point number from the binary input stream, put it into the ring RR."
     }
document { "ggdrop",
     TT "ggdrop", " -- gbengine command string.",
     PARA,
     "arguments: vn .. v0 (n:int) >> v(n-1) .. v0",
     PARA,
     "Remove the n th element from the stack."
     }
document { "ggdup",
     TT "ggdup", " -- gbengine command string.",
     PARA,
     "arguments: v0 >> v0 v0",
     PARA,
     "Push a copy of the top element on the stack."
     }
document { "ggduplicate",
     TT "ggduplicate", " -- gbengine command string.",
     PARA,
     "arguments: vn .. v0 (n:int) >> vn .. v0 vn",
     PARA,
     "Push a copy of the n th element on the stack."
     }
document { "ggelem",
     TT "ggelem", " -- gbengine command string.",
     PARA,
     "arguments: v:Vector r:int >> RingElement;  OR  m:Matrix c:int >> Vector;  OR  m:Matrix r:int c:int >> RingElement OR m:SparseMutableMatrix r:int c:int >> RingElement",
     PARA,
     "Vector version: yields the r th coefficient of the vector.  Matrix versions: Place either the c th column of the matrix, or the (r,c) th entry of the matrix onto the stack."
     }
document { "ggelim",
     TT "ggelim", " -- gbengine command string.",
     PARA,
     "arguments: matrix n:int >> intarray",
     PARA,
     "Yields an integer array having the indices of those columns of the matrix whose initial term is zero on the first n weight vectors."
     }
document { "ggev",
     TT "ggev", " -- gbengine command string.",
     PARA,
     "arguments: map:matrix source:matrix >> matrix",
     PARA,
     "Evaluate the source matrix under the map sending the i th variable to the i th entry of map, where both indices count starting at zero."
     }
document { "ggexterior",
     TT "ggexterior", " -- gbengine command string.",
     PARA,
     "arguments: F:freemodule d:int >> freemodule, OR m:matrix d:int >> matrix",
     PARA,
     "Return the d th exterior power of F or m."
     }
document { "ggexteriorproduct",
     TT "ggexteriorproduct", " -- gbengine command string.",
     PARA,
     "arguments: p:int q:int F:freemodule >> m:matrix",
     PARA,
     "Return the matrix which represents the multiplication wedge(p)(F) ** wedge(q)(F) --> wedge(p+q)(F)."
     }
document { "ggFFgausselim",
     TT "ggFFgausselim", " -- gbengine command string.",
     PARA,
     "arguments: Performs a fraction-free (Bareiss) Gaussian elimination on the columns of M (which is modified in place), the permutation integer array on the columns of M is returned.",
     PARA,
     ""
     }
document { "ggfactor",
     TT "ggfactor", " -- gbengine command string.",
     PARA,
     "arguments: ... >> ...",
     PARA,
     "experimental"
     }
document { "ggfactor1",
     TT "ggfactor1", " -- gbengine command string.",
     PARA,
     "arguments: ... >> ...",
     PARA,
     "experimental"
     }
document { "ggfactor2",
     TT "ggfactor2", " -- gbengine command string.",
     PARA,
     "arguments: ... >> ...",
     PARA,
     "experimental"
     }
document { "ggfindGoodUnitPivot",
     TT "ggfindGoodUnitPivot", " -- gbengine command string.",
     PARA,
     "arguments: m:SparseMutableMatrix c1:int c2:int >> r:int c:int",
     PARA,
     "Find a unit (currently: only checks for 1, -1), m[r,c], which would minimize 'fill-ins', at least in the range of columns c1..c2.  If no 1 or -1 is found in the matrix in this range of columns, then r and c are both set to -1."
     }
document { "ggflip",
     TT "ggflip", " -- gbengine command string.",
     PARA,
     "arguments: F:freemodule G:freemodule >> matrix",
     PARA,
     "Yields the matrix representing the map F ** G --> G ** F."
     }
document { "ggforget",
     TT "ggforget", " -- gbengine command string.",
     PARA,
     "arguments: h:int >> .",
     PARA,
     "Remove a reference to the given integer handle.  This should match an original call to ggaddress."
     }
document { "ggfraction",
     TT "ggfraction", " -- gbengine command string.",
     PARA,
     "arguments: R:Ring a:RingElement b:RingElement >> RingElement",
     PARA,
     "Yields the element a/b in the fraction field R, if R is the fraction field of the rings of a and b.  If not, an error is returned."
     }
document { "ggfractionfield",
     TT "ggfractionfield", " -- gbengine command string.",
     PARA,
     "arguments: R:ring >> K:field",
     PARA,
     "Given a domain 'R', create its field of fractions, 'K'."
     }
document { "ggfree",
     TT "ggfree", " -- gbengine command string.",
     PARA,
     "arguments: V:vecinfo intarray >> freemodule;  OR  V:vecinfo n:int >> freemodule",
     PARA,
     "Create a free module over the base ring of V which has as its degrees the entries of the intarray (first case), or has rank 'n', all of whose degrees are zero (second case)."
     }
document { "ggfromdouble",
     TT "ggfromdouble", " -- gbengine command string.",
     PARA,
     "arguments: R:Ring n:double >> RingElement",
     PARA,
     "Return the double precision integer n as an element of R.  If R is not a ring over the reals RR, then n is coerved to an integer first, and then put into the ring R."
     }
document { "ggfromint",
     TT "ggfromint", " -- gbengine command string.",
     PARA,
     "arguments: ring int >> ringelem",
     PARA,
     "Return an element of the given ring with the given integer value."
     }
document { "gggb",
     TT "gggb", " -- gbengine command string.",
     PARA,
     "arguments: matrix >> gbasis; or matrix syztype:int n:int >> groebner_comp",
     PARA,
     "Create a Groebner basis computation."
     }
document { "gggcd",
     TT "gggcd", " -- gbengine command string.",
     PARA,
     "arguments: a:ringelem b:ringelem >> g:ringelem; OR monomial monomial >> monomial;",
     PARA,
     "Place the gcd of the two elements onto the stack, if gcd's are defined."
     }
document { "gggcdextended",
     TT "gggcdextended", " -- gbengine command string.",
     PARA,
     "arguments: a:ringelem b:ringelem >> g:ringelem x:ringelem y:ringelem",
     PARA,
     "Return the greatest common divisor, g, of a and b, if gcd's are defined over this ring.  The following is satisfied: ax+by = g."
     }
document { "gggetchange",
     TT "gggetchange", " -- gbengine command string.",
     PARA,
     "arguments: gbasis >> matrix",
     PARA,
     "Return the change of basis matrix from the Groebner basis to another generating set, usually a minimal, or original, generating set."
     }
document { "gggetcoeff",
     TT "gggetcoeff", " -- gbengine command string.",
     PARA,
     "arguments: f:ringelem m:monomial >> a:ringelem",
     PARA,
     "Yields the (possibly zero) coefficient of the monomial 'm' in the polynomial 'f'."
     }
document { "gggetCoefficientRing",
     TT "gggetCoefficientRing", " -- gbengine command string.",
     PARA,
     "arguments: Returns the coefficient ring of R.",
     PARA,
     ""
     }
document { "gggetColChange",
     TT "gggetColChange", " -- gbengine command string.",
     PARA,
     "arguments: m:SparseMutableMatrix >> n:SparseMutableMatrix",
     PARA,
     "Return the column operation recording matrix for 'm', if one has been set.  If not, an error is given."
     }
document { "gggetcols",
     TT "gggetcols", " -- gbengine command string.",
     PARA,
     "arguments: matrix >> intarray",
     PARA,
     "Place the column degrees of the matrix onto the stack."
     }
document { "gggetideal",
     TT "gggetideal", " -- gbengine command string.",
     PARA,
     "arguments: R:ring >> I:matrix",
     PARA,
     "If R is a quotient ring S/I, of a polynomial ring S, then place onto the stack the one row matrix consisting of the generators of a minimal GB of I."
     }
document { "gggetFreeModule",
     TT "gggetFreeModule", " -- gbengine command string.",
     PARA,
     "arguments: v:EVector >> EFreeModule",
     PARA,
     "Returns the free module which contains the vector v."
     }
document { "gggetgb",
     TT "gggetgb", " -- gbengine command string.",
     PARA,
     "arguments: gbasis >> matrix",
     PARA,
     "Place the Groebner basis (as far as it has been computed) onto the stack."
     }
document { "gggetMO",
     TT "gggetMO", " -- gbengine command string.",
     PARA,
     "arguments: M:EMonoid >> EMonomialOrder",
     PARA,
     "Returns (a copy of) the monomial order in M."
     }
document { "gggetMonoid",
     TT "gggetMonoid", " -- gbengine command string.",
     PARA,
     "arguments: R:ERing >> EMonoid",
     PARA,
     "Returns the monoid used to construct the (polynomial) ring R."
     }
document { "gggetmingens",
     TT "gggetmingens", " -- gbengine command string.",
     PARA,
     "arguments: gbasis >> matrix",
     PARA,
     "Place the matrix whose columns are minimal generators of the submodule with the given Groebner basis (at least as it has so far been computed)."
     }
document { "gggetring",
     TT "gggetring", " -- gbengine command string.",
     PARA,
     "arguments: var >> ring",
     PARA,
     "Place the base ring of the given variable onto the stack.  If that variable does not have a base ring (e.g. an int), then put the current ring onto the stack."
     }
document { "gggetRingFreeModule",
     TT "gggetRingFreeModule", " -- gbengine command string.",
     PARA,
     "arguments: R:ERing >> EFreeModule",
     PARA,
     "Returns the free module R^1."
     }
document { "gggetRowChange",
     TT "gggetRowChange", " -- gbengine command string.",
     PARA,
     "arguments: m:SparseMutableMatrix >> n:SparseMutableMatrix",
     PARA,
     "Return the row operation recording matrix for 'm', if one has been set.  If not, an error is given."
     }
document { "gggetColumnChange",
     TT "gggetColumnChange", " -- gbengine command string.",
     PARA,
     "arguments: m:SparseMutableMatrix >> n:SparseMutableMatrix",
     PARA,
     "Return the column operation recording matrix for 'm', if one has been set.  If not, an error is given."
     }
document { "gggetrows",
     TT "gggetrows", " -- gbengine command string.",
     PARA,
     "arguments: matrix >> intarray",
     PARA,
     "Place the row degrees of the given matrix onto the stack."
     }
document { "gggetshift",
     TT "gggetshift", " -- gbengine command string.",
     PARA,
     "arguments: matrix >> intarray",
     PARA,
     "Yields the (multi-)degree of the matrix."
     }
document { "gggetsubring",
     TT "gggetsubring", " -- gbengine command string.",
     PARA,
     "arguments: g:binomialGB_comp n:int >> m:matrix",
     PARA,
     "Yields a generating set for the subideal of the given binomial ideal whose first 'n' wieght vectors are zero.  This will often be a minimal generating set, if that is computed during the GB computation."
     }
document { "gggetsubringGB",
     TT "gggetsubringGB", " -- gbengine command string.",
     PARA,
     "arguments: g:binomialGB_comp n:int >> m:matrix",
     PARA,
     "Yields a one row matrix whose entries form the Groebner basis of the given binomial ideal, as so far computed."
     }
document { "gggetsyz",
     TT "gggetsyz", " -- gbengine command string.",
     PARA,
     "arguments: gbasis >> matrix",
     PARA,
     "Place the (non-minimal) syzygy matrix computed in gbasis onto the stack."
     }
document { "gggetterms",
     TT "gggetterms", " -- gbengine command string.",
     PARA,
     "arguments: ringelem lo:int hi:int >> ringelem;  OR  vector lo:int hi:int >> vector",
     PARA,
     "Yields the sum of all terms within the given indices (inclusive).  If either lo or hi is less than zero, then they refer to the last indices.  For example, if lo=-3, and hi=-1, then this chooses the last three monomials of a polynomial."
     }
document { "gggetvalue",
     TT "gggetvalue", " -- gbengine command string.",
     PARA,
     "arguments: h:hilb_comp >> ringelement",
     PARA,
     "Yields the so-called Poincare polynomial (the numerator of the Hilbert series) if the computation has been completed.  If the computation is not yet complete, an error is issued."
     }
document { "gggetzerodivisor",
     TT "gggetzerodivisor", " -- gbengine command string.",
     PARA,
     "arguments: R:Ring >> RingElement",
     PARA,
     "If the ring R has been found to have a zero divisor, this yields that element.  If not, the zero element is returned."
     }
document { "ggrandom",
     TT "ggrandom", " -- gbengine command string.",
     PARA,
     "arguments: F:freemodule G:freemodule n:int deg:intarray >> matrix  OR  R:ring >> ringelem",
     PARA,
     "Return a matrix of degree 'deg' between graded free modules F <-- G.  If 'n' is less than zero,"
     }
document { "ggrandomint",
     TT "ggrandomint", " -- gbengine command string.",
     PARA,
     "arguments: n:int >> int",
     PARA,
     "Return a random integer in the range 0..n-1, where n is positive arbitrary precision integer.  The algorithm used is described briefly in the documentation for ggrandomseed."
     }
document { "ggrandommax",
     TT "ggrandommax", " -- gbengine command string.",
     PARA,
     "arguments: n:int >> int",
     PARA,
     "Set the maximum integer value that ggrandom or ggrandomint will return.  Random rational numbers will have both numerator and denominator bounded by this value.  The returned value is the current bound."
     }
document { "ggrandomseed",
     TT "ggrandomseed", " -- gbengine command string.",
     PARA,
     "arguments: n:int >> .",
     PARA,
     "Set the random number generator seed to the given number. The seed is initially set to zero.  The random generator currently used is the 'minimal' random generator of Park and Miller, described in the book 'Numerical recipes in C'.  Currently only the low 32 bits of 'n' are used for the seed."
     }
document { "ggrank",
     TT "ggrank", " -- gbengine command string.",
     PARA,
     "arguments: Returns the rank of the free module F.",
     PARA,
     ""
     }
document { "ggreducepivots",
     TT "ggreducepivots", " -- gbengine command string.",
     PARA,
     "arguments: m:SparseMutableMatrix >> SparseMutableMatrix",
     PARA,
     "Takes a matrix, reduces all possible pivots, and returns the compressed matrix."
     }
document { "ggremote",
     TT "ggremote", " -- gbengine command string.",
     PARA,
     "arguments: matrix mach:string user:string s:string cmd:string >> remote_gb_comp",
     PARA,
     "Create a remote Groebner basis computation.  In development."
     }
document { "gghash",
     TT "gghash", " -- gbengine command string.",
     PARA,
     "arguments: Returns an integer hash(f) (usually 32 bit, signed) such that given two objects f and g, f==g implies that hash(f) == hash(g).",
     PARA,
     ""
     }
document { "ggheap",
     TT "ggheap", " -- gbengine command string.",
     PARA,
     "arguments: . >> string",
     PARA,
     "Push a string containing the types of the heap elements."
     }
document { "gghermite",
     TT "gghermite", " -- gbengine command string.",
     PARA,
     "arguments: m:matrix collectsyz:int ncomps:int >> hermite_computation",
     PARA,
     "Create the computation of the Hermite normal form of the matrix 'm' over the integers.  This is essentially a Groebner basis for the submodule of Z^n generated by the columns of 'm'.  The elements 'collectsyz' and 'ncomps' have the same meaning that they have for Groebner basis computations."
     }
document { "gghilb",
     TT "gghilb", " -- gbengine command string.",
     PARA,
     "arguments: R:ring matrix >> denom:ring_elem numer:ring_elem; OR  R:ring monideal >> ring_elem",
     PARA,
     "Compute the numerator of the Hilbert series (the Poincare polynomial) of the given monomial ideal, or of the monomial submodule generated by the initial terms of the given matrix. The result is a ring element in the ring R, involving the first 'd' variables in that ring, where 'd' is the size of the degree vector.  In the first form, because the degrees of the rows may be negative, the first result is a monomial for which numer/denom is the Poincare polynomial."
     }
document { "gghomogenize",
     TT "gghomogenize", " -- gbengine command string.",
     PARA,
     "arguments: m:matrix n:int >> matrix",
     PARA,
     "Homogenize the given matrix using the n th variable in the ring to homogenize.  An error is given if the resulting matrix cannot be made (multi-)homogeneous.  The matrix m could also be a ring element."
     }
document { "gghomogenize1",
     TT "gghomogenize1", " -- gbengine command string.",
     PARA,
     "arguments: m:ring_elem deg:intarray n:int >> ring_elem",
     PARA,
     "Homogenize the given ring element using the n th variable in the ring to homogenize.  An error is given if the resulting matrix cannot be made (multi-)homogeneous.  The degree 'deg' is the target degree."
     }
document { "ggiden",
     TT "ggiden", " -- gbengine command string.",
     PARA,
     "arguments: F:freemodule >> matrix",
     PARA,
     "Place the identity matrix F --> F onto the stack."
     }
document { "ggindex",
     TT "ggindex", " -- gbengine command string.",
     PARA,
     "arguments: array int >> var,  or  intarray int >> int",
     PARA,
     "Place the given element of the given array onto the stack."
     }
document { "gginitial",
     TT "gginitial", " -- gbengine command string.",
     PARA,
     "arguments: m:matrix w:int >> matrix;  OR  gbasis n:int >> monideal.",
     PARA,
     "Return the matrix of initial forms of m.  The initial term of a vector consists of those monomials which have the same value as the lead monomial on the first 'w' weight vectors.  w=-1 gives the usual lead term. The second form returns the monomial ideal of initial forms which occur in the n th row."
     }
document { "ggINT",
     TT "ggINT", " -- gbengine command string.",
     PARA,
     "arguments: >> int",
     PARA,
     "Read an integer from the binary input stream."
     }
document { "ggINTARRAY",
     TT "ggINTARRAY", " -- gbengine command string.",
     PARA,
     "arguments: >> intarray",
     PARA,
     "Read an integer array from the binary input stream.  The format is: the length, followed by each entry.  Each of these integers is also in the binary format."
     }
document { "ggintersect",
     TT "ggintersect", " -- gbengine command string.",
     PARA,
     "arguments: monideal monideal >> monideal",
     PARA,
     "Place the intersection of the two monomial ideals onto the stack."
     }
document { "ggisborel",
     TT "ggisborel", " -- gbengine command string.",
     PARA,
     "arguments: mi:monideal >> int",
     PARA,
     "Return whether 'mi' is a borel fixed monomial ideal."
     }
document { "ggisequal",
     TT "ggisequal", " -- gbengine command string.",
     PARA,
     "arguments: f g >> bool [type of f,g is ringelem, vector, freemodule, matrix, gbcomp, monideal, monomial, ring]",
     PARA,
     "Yields true(1) or false(0) depending on whether f and g are equal."
     }
document { "ggisequal0",
     TT "ggisequal0", " -- gbengine command string.",
     PARA,
     "arguments: f:object g:object >> bool",
     PARA,
     "Return whether f and g are equal.  For this function, equality is defined as follows: f and g can only be equal if they have exactly the same type in the engine, and if so, they must point to the exact same object, except in the cases when the common type is: RingElement, Monomial, and Vector.  In these cases, equality is checked as in ggisequal: they must be the same element in the same (as defined above) ring or free module.  This routine exists to allow ring elements and vectors to be used as keys in hashtables."
     }
document { "ggishomogeneous",
     TT "ggishomogeneous", " -- gbengine command string.",
     PARA,
     "arguments: f >> bool  [f is a ringelem, vector, or matrix]",
     PARA,
     "Yields true(1) or false(0), depending on whether 'f'is (multi-)homogeneous.  If the base ring is not homogeneous, then this will always yield false."
     }
document { "ggissubset",
     TT "ggissubset", " -- gbengine command string.",
     PARA,
     "arguments: m:matrix gb:gbcomp >> int",
     PARA,
     "If some column of the matrix 'm' does not reduce to zero w.r.t. gb, return the index of the first such column, otherwise return -1."
     }
document { "ggiszero",
     TT "ggiszero", " -- gbengine command string.",
     PARA,
     "arguments: a:ringelem >> int",
     PARA,
     "Place a 1 on the stack if a is zero, otherwise place a 0 on the stack."
     }
document { "ggkbasis",
     TT "ggkbasis", " -- gbengine command string.",
     PARA,
     "arguments: top:matrix bottom:matrix d:deg >> matrix",
     PARA,
     "Form a matrix whose columns form a k-basis of the module (image(top)/image(bottom)) in degree d.  It is assumed that the columns of 'top' and 'bottom' form Groebner bases, and that they have the same row space.  If d = {}, then a k-basis for the whole module is returned."
     }
document { "ggkbasisIn",
     TT "ggkbasisIn", " -- gbengine command string.",
     PARA,
     "arguments: m:matrix deg:intarray >> matrix",
     PARA,
     "Yields a matrix 'n' such that 'm n' is a matrix whose columns form a k-basis for the submodule image(m) in degree 'deg'.  If 'm' is not a Groebner basis, then this set generates image(m) in degree 'deg', but may not be independent."
     }
document { "ggkbasisOut",
     TT "ggkbasisOut", " -- gbengine command string.",
     PARA,
     "arguments: m:matrix deg:intarray >> matrix",
     PARA,
     "Yields a matrix consisting of monomials such that the columns consist of all monomials of degree 'deg' that are not in the monomial submodule of lead terms of the matrix 'm'."
     }
document { "ggker",
     TT "ggker", " -- gbengine command string.",
     PARA,
     "arguments: matrix h:int >> gbasis",
     PARA,
     "Create a Groebner basis computation to compute the first h components of each syzygy of the given matrix."
     }
document { "ggkoszul",
     TT "ggkoszul", " -- gbengine command string.",
     PARA,
     "arguments: M:matrix p:int >> matrix",
     PARA,
     "Place the p th koszul matrix of M onto the stack.  M should be a matrix with exactly one row."
     }
document { "gglcm",
     TT "gglcm", " -- gbengine command string.",
     PARA,
     "arguments: monomial monomial >> monomial",
     PARA,
     "Place the l.c.m. othe the two monomials onto the stack."
     }
document { "gglength",
     TT "gglength", " -- gbengine command string.",
     PARA,
     "arguments: object >> int",
     PARA,
     "Yields the length of the given object.  The definition of length is type specific.  For example, for polynomials it is the number of non-zero monomials, for vectors it is the number of non-zero components, for freemodules it is the rank, and for matrices it is the number of columns."
     }
document { "ggleadcoeff",
     TT "ggleadcoeff", " -- gbengine command string.",
     PARA,
     "arguments: f:ringelem >> ringelem",
     PARA,
     "Place the coefficient of the lead term onto the stack.  Its base ring is the coefficient ring of the base ring of f, if f is a polynomial."
     }
document { "ggleadcomp",
     TT "ggleadcomp", " -- gbengine command string.",
     PARA,
     "arguments: f:vector >> int",
     PARA,
     "Returns the lead component of the non-zero vector f."
     }
document { "ggleadmonom",
     TT "ggleadmonom", " -- gbengine command string.",
     PARA,
     "arguments: ringelem >> ringelem",
     PARA,
     "Place the lead monomial (with coefficient 1) onto the stack."
     }
document { "ggleadterm",
     TT "ggleadterm", " -- gbengine command string.",
     PARA,
     "arguments: ringelem >> ringelem",
     PARA,
     "Place the lead term (coefficient plus monomial) onto the stack."
     }
document { "gglift",
     TT "gglift", " -- gbengine command string.",
     PARA,
     "arguments: S:ring f:ringelem >> g:ringelem",
     PARA,
     "Lift f to an element g of S.  If R is the base ring of f, then S ---> R should be one of the following extensions: (1) R ---> R (in which case f is returned without change), (2) S ---> R=S/I, (in which case f can always be lifted: note that S itself may be a quotient base ring of R), (3) S ---> R=S[x1..xn], (an error is returned if f is not a scalar), (4) S ---> R=frac S, (an error is returned if f is not an element of S), (5) S=Z/p[x]/(F(x)) ---> GF(p,n).  An error indication is returned if the ring extension is not one of these, or in the situations indicated."
     }
document { "ggLLLinit",
     TT "ggLLLinit", " -- gbengine command string.",
     PARA,
     "arguments: m:Matrix threshold:RingElement flag:int >> A:SparseMutableMatrix LLLstate:SparseMutableMatrix",
     PARA,
     "Setup the computation of the LLL reduction of the matrix 'm' (over ZZ).  There is no engine LLL computation object.  Instead, the answer will appear in 'A' (after using ggLLLcalc), using the internal state 'LLLstate'.  The threshold should be an element of ZZ or QQ, in the range (1/4, 1].  If flag is non-zero, then the change of basis column multiplier matrix for 'A' is set.  After the computation is complete (or before, to view the partial answer), this multiplier matrix B can be obtained using gggetColChange on A.  The final answers satisfy: A = m*B.  For more information about LLL reduction, see H. Cohen, A Course in Computational Algebraic Number Theory, Springer Lecture notes in Math, 138."
     }
document { "ggLLLcalc",
     TT "ggLLLcalc", " -- gbengine command string.",
     PARA,
     "arguments: A:SparseMutableMatrix LLLstate:SparseMutableMatrix nsteps:int >> int",
     PARA,
     "Compute the LLL reduction of the matrix A, using the state setup originally by ggLLLinit.  Compute 'nsteps' amount.  If this is -1, compute until done, or interrupted.  See the documentation for ggLLLinit for more information.  Return values: if an error: -2 (e.g. the columns of 'A' are not independent), if completely done: 0, if interrupted: -1, if done with the given number of steps, but not completely done: 9."
     }
document { "ggmatrix",
     TT "ggmatrix", " -- gbengine command string.",
     PARA,
     "arguments: v0 v1 ... v(c-1) rows:freemodule cols:freemodule >> matrix;  OR  v0 v1 ... v(c-1) rows:freemodule c:int >> matrix;  OR  vecinfo monideal >> matrix",
     PARA,
     "In the first two forms, create a matrix having the given rows, and the columns of the matrix are v0, ..., v(c-1).  In the first form, the column free module is set to 'cols', while in the second form, the column degrees are computed.  The third form creates a one row matrix whose entries are the monomials in the given monomial ideal."
     }
document { "ggmem",
     TT "ggmem", " -- gbengine command string.",
     PARA,
     "arguments: . >> .",
     PARA,
     "Place some user readable memory usage information onto the output string."
     }
document { "ggminleadterms",
     TT "ggminleadterms", " -- gbengine command string.",
     PARA,
     "arguments: m:matrix >> intarray",
     PARA,
     "Returns the indices of the columns of 'm' whose lead terms minimally generate the lead monomial, or term, submodule."
     }
document { "ggmod",
     TT "ggmod", " -- gbengine command string.",
     PARA,
     "arguments: a:ringelem b:ringelem >> ringelem",
     PARA,
     "Compute the remainder of dividing a by b, if division is defined in the ring of a and b."
     }
document { "ggmodtensor",
     TT "ggmodtensor", " -- gbengine command string.",
     PARA,
     "arguments: m:matrix n:matrix >> matrix",
     PARA,
     "Yields a matrix which presents coker(m) tensor coker(n)."
     }
document { "ggmonideal",
     TT "ggmonideal", " -- gbengine command string.",
     PARA,
     "arguments: M:matrix n:int >> monideal",
     PARA,
     "Return the monomial ideal of those columns of M whose lead terms are in row n."
     }
document { "ggmonoid",
     TT "ggmonoid", " -- gbengine command string.",
     PARA,
     "arguments: n:int degrees:intarray weights:intarray",
     PARA,
     "Create a monoid having n variables, which has the gradings from 'degrees' and the ordering from 'weights'"
     }
document { "ggMOclone",
     TT "ggMOclone", " -- gbengine command string.",
     PARA,
     "arguments: mo:MonomialOrder >> mo':MonomialOrder",
     PARA,
     "Create a new copy of 'mo'."
     }
document { "ggMOcomponent",
     TT "ggMOcomponent", " -- gbengine command string.",
     PARA,
     "arguments: mo:MonomialOrder >> .",
     PARA,
     "While creating a monomial order, place the component as the next slot."
     }
document { "ggMOelim",
     TT "ggMOelim", " -- gbengine command string.",
     PARA,
     "arguments: mo1:mon_order mo2:monorder >> monorder",
     PARA,
     "Form the product elimination order."
     }
document { "ggMOinit",
     TT "ggMOinit", " -- gbengine command string.",
     PARA,
     "arguments: . >> MonomialOrder",
     PARA,
     "Start the creation of a MonomialOrder.  One must then call a sequence of the routines: ggMOclone, ggMOrevlex, ggMOlex, ggMOcomponent, ggMOwtfcn, ggMOproduct, ggMONClex."
     }
document { "ggMOgeneral",
     TT "ggMOgeneral", " -- gbengine command string.",
     PARA,
     "arguments: d:intarray order:intarray invorder:intarray invdegs:intarray >> monorder",
     PARA,
     "Create an engine 'mon_order', where 'd' is a (totally positive) vector of length 'n' of degrees, 'order' is a flattened n by n matrix of integers giving the order (i.e. given two monomials having exponent vectors m1, m2, then m1 > m2 iff (order*m1) > (order*m2) in the lexicographic order.  'invorder' is a (flattened) integral matrix such that (order * invorder == diagonal matrix whose entries are 'invdegs'."
     }
document { "ggMOglex",
     TT "ggMOglex", " -- gbengine command string.",
     PARA,
     "arguments: d:intarray >> monorder",
     PARA,
     "Create an engine 'mon_order', which is graded lex order on a set of variables, where 'd' consists of the degrees of these variables."
     }
document { "ggMOgproduct",
     TT "ggMOgproduct", " -- gbengine command string.",
     PARA,
     "arguments: mo1:mon_order mo2:monorder >> monorder",
     PARA,
     "Form the graded product order."
     }
document { "ggMOgrevlex",
     TT "ggMOgrevlex", " -- gbengine command string.",
     PARA,
     "arguments: d:intarray >> monorder",
     PARA,
     "Create an engine 'mon_order', which is graded reverse lex order on a set of variables, where 'd' consists of the degrees of these variables."
     }
document { "ggMOlex",
     TT "ggMOlex", " -- gbengine command string.",
     PARA,
     "arguments: d:intarray >> monorder",
     PARA,
     "Create an engine 'mon_order', which is lex order on a set of variables, where 'd' consists of the degrees of these variables."
     }
document { "ggMONClex",
     TT "ggMONClex", " -- gbengine command string.",
     PARA,
     "arguments: mo:MonomialOrder nvars:int >> .",
     PARA,
     "Append a block of non-commuting 'nvars' variables as the next part of the monomial order.  The order in this block is the lexicographic order."
     }
document { "ggMOproduct",
     TT "ggMOproduct", " -- gbengine command string.",
     PARA,
     "arguments: mo1:mon_order mo2:monorder >> monorder",
     PARA,
     "Form the product order."
     }
document { "ggMOrevlex",
     TT "ggMOrevlex", " -- gbengine command string.",
     PARA,
     "arguments: d:intarray >> monorder",
     PARA,
     "Create an engine 'mon_order', which is (non-graded) reverse lex order on a set of variables, where 'd' consists of the degrees of these variables."
     }
document { "ggMOwtfcn",
     TT "ggMOwtfcn", " -- gbengine command string.",
     PARA,
     "arguments: degs:intarray wtfcn:intarray >> monorder",
     PARA,
     "Form the monomial order which is graded using 'degs'.  MES"
     }
document { "ggMONOMIAL",
     TT "ggMONOMIAL", " -- gbengine command string.",
     PARA,
     "arguments: monoid >> monomial",
     PARA,
     "Read from the input stream a monomial which is in the binary format (i.e. the number of variable/exponent pairs, followed by the sequence of variables and exponents.  Each of these integers is also in the binary format."
     }
document { "ggmonsyz",
     TT "ggmonsyz", " -- gbengine command string.",
     PARA,
     "arguments: matrix >> matrix;  a:monomial b:monomial >> c:monomial d:monomial",
     PARA,
     "In the first case, place the monomial syzygies on the lead terms of the given matrix onto the stack.  For monomials, place the monomials c, d onto the stack, where a c = b d = lcm(a,b)."
     }
document { "ggmult",
     TT "ggmult", " -- gbengine command string.",
     PARA,
     "arguments: f g >> f*g: ",
     PARA,
     "Multiply f and g.  If f and g are free modules, then the result is the tensor product. [type,f,type g] = [ringelem,vector], [vector,ringelem], [ringelem,matrix], [matrix,matrix], [matrix,vector], [monideal, monideal], [monomial,monomial], [ringelem, ringelem], [freemodule, freemodule]."
     }
document { "ggnegate",
     TT "ggnegate", " -- gbengine command string.",
     PARA,
     "arguments: matrix >> matrix",
     PARA,
     "Place the negation of the given matrix onto the stack."
     }
document { "ggnmonoms",
     TT "ggnmonoms", " -- gbengine command string.",
     PARA,
     "arguments: res_comp >> intarray",
     PARA,
     "Return an intarray in the same format as in 'ggpairs' describing the number of monomials present in each level/degree of the resolution."
     }
document { "ggnumcols",
     TT "ggnumcols", " -- gbengine command string.",
     PARA,
     "arguments: m:SparseMutableMatrix >> int",
     PARA,
     "Yields the number of columns of 'm'."
     }
document { "ggnumerator",
     TT "ggnumerator", " -- gbengine command string.",
     PARA,
     "arguments: f:ringelem >> g:ringelem",
     PARA,
     "If f = g/h is an element of a fraction field frac(R), return the numerator g in R."
     }
document { "ggnumrows",
     TT "ggnumrows", " -- gbengine command string.",
     PARA,
     "arguments: m:SparseMutableMatrix >> int",
     PARA,
     "Yields the number of rows of 'm'."
     }
document { "ggnvars",
     TT "ggnvars", " -- gbengine command string.",
     PARA,
     "arguments: M:EMonoid >> int",
     PARA,
     "Returns the number of variables in M."
     }
document { "ggpairs",
     TT "ggpairs", " -- gbengine command string.",
     PARA,
     "arguments: res_comp >> intarray",
     PARA,
     "Return an intarray describing upper bounds on the graded betti numbers.  Equivalently, these numbers represent the number of S-pair computations that have been/or will be computed.  The format for this array is: [low degree, high degree, max level, b0, b1, ...], where the betti numbers have been flattened by rows.  Thus, b_((i-lo)*len + lev) gives the number of elements at level 'lev' in slanted degree 'i', where lo, hi, len are the first three elements in the output intarray."
     }
document { "ggpermute",
     TT "ggpermute", " -- gbengine command string.",
     PARA,
     "arguments: m:SparseMutableMatrix lo:int hi:int perm:intarray >> .",
     PARA,
     "Permute the columns lo..hi of 'm' using the elements perm[0]..perm[hi-lo+1].  That is, column c is moved to column perm[c-lo]."
     }
document { "ggpfaffs",
     TT "ggpfaffs", " -- gbengine command string.",
     PARA,
     "arguments: m:matrix p:int >> pfaffian computation",
     PARA,
     "Create a computation which will yield the p by p pfaffians of the skew symmetric matrix m."
     }
document { "ggpick",
     TT "ggpick", " -- gbengine command string.",
     PARA,
     "arguments: vn v(n-1) ... v1 v0 (n:int) >> v(n-1) ... v1 v0 vn ",
     PARA,
     "Move the n th element to the top of the stack."
     }
document { "ggpolyring",
     TT "ggpolyring", " -- gbengine command string.",
     PARA,
     "arguments: ring monoid >> ring",
     PARA,
     "Create the polynomial ring (i.e. monoid ring) wirh coefficients from the given ring, and monomials from the given monoid."
     }
document { "ggpop",
     TT "ggpop", " -- gbengine command string.",
     PARA,
     "arguments: v1 v0 >> v1",
     PARA,
     "Remove the top element from the stack."
     }
document { "ggpoppem",
     TT "ggpoppem", " -- gbengine command string.",
     PARA,
     "arguments: v(n-1) ... v1 v0 n:int >> .",
     PARA,
     "Remove the top n elements from the stack."
     }
document { "ggpower",
     TT "ggpower", " -- gbengine command string.",
     PARA,
     "arguments: f:ringelem n:int >> ringelem",
     PARA,
     "Place f^n onto the stack.  If f is a polynomial, the binomial method is used to compute the exponent."
     }
document { "ggprimes",
     TT "ggprimes", " -- gbengine command string.",
     PARA,
     "arguments: monideal >> monideal",
     PARA,
     "Yields a monomial ideal whose monomials are in one to one correspondence with the associated primes of minimal codimension.  Each monomial corresponds to the prime monomial ideal generated by the variables its support."
     }
document { "ggpromote",
     TT "ggpromote", " -- gbengine command string.",
     PARA,
     "arguments: R:ring f:ringelem >> g:ringelem",
     PARA,
     "Promote f to an element g of R.  If S is the base ring of f, then S ---> R should be one of the following extensions: (1) R ---> R (in which case f is returned without change), (2) S ---> R=S/I, (3) S ---> R=S[x1..xn], (4) S ---> R=frac S, (5) S=Z/p[x]/(F(x)) ---> GF(p,n).  An error indication is returned if the ring extension is not one of these."
     }
document { "ggqring",
     TT "ggqring", " -- gbengine command string.",
     PARA,
     "arguments: I:matrix >> R:ring;  OR f1 ... fn n A:ring >> R:ring",
     PARA,
     "Create the ring R = A/I, where A is the ring of I, and I is a 1 by r matrix with entries in the polynomial ring (or quotient of a polynomial ring) A.  In the second version I is the ideal generated by the f1, ..., fn, which should be elements of A.  Currently, in either case the generators should form a Groebner basis, whose lead terms are all monic."
     }
document { "ggquit",
     TT "ggquit", " -- gbengine command string.",
     PARA,
     "arguments: . >> .",
     PARA,
     "Quit the engine"
     }
document { "ggradical",
     TT "ggradical", " -- gbengine command string.",
     PARA,
     "arguments: monideal >> monideal;  OR  monomial >> monomial.",
     PARA,
     "Yields the radical of the given monomial (ideal)."
     }
document { "ggreduce",
     TT "ggreduce", " -- gbengine command string.",
     PARA,
     "arguments: gbasis matrix >> red:matrix lift:matrix",
     PARA,
     "Reduce the given matrix using the Groebner basis, obtaining the matrix red.  The matrix lift is the corresponding matrix.  MES ************* improve this."
     }
document { "ggremaining",
     TT "ggremaining", " -- gbengine command string.",
     PARA,
     "arguments: res_comp >> intarray",
     PARA,
     "Return an intarray describing the number of S-pair computations that remain to be computed.  The format for the array is that of 'ggpairs'."
     }
document { "ggringmap",
     TT "ggringmap", " -- gbengine command string.",
     PARA,
     "arguments: m:matrix >> f:ringmap;  OR  I:ideal >> f:ringmap",
     PARA,
     "Create a ring map f : (any ring S) --> (ring m).  The i th variable of S is mapped to the i th element of (the first row of) m, or the i th element of I, using the engine command 'ggev'."
     }
document { "ggreceive",
     TT "ggreceive", " -- gbengine command string.",
     PARA,
     "arguments: remote_gb_comp >> matrix",
     PARA,
     "Return the Groebner basis matrix so far computed with the remote GB routine.  In development."
     }
document { "ggremove",
     TT "ggremove", " -- gbengine command string.",
     PARA,
     "arguments: monideal >> int monomial",
     PARA,
     "Remove the lexicographically largest element from the monomial ideal.  Place its integer number and the actual monomial onto the stack.  If the monideal is empty, raise an error."
     }
document { "ggres",
     TT "ggres", " -- gbengine command string.",
     PARA,
     "arguments: m:matrix >> res_comp",
     PARA,
     "Create a computation to compute the free resolution of m.  The computation itself should be done using ggcalc or ggcalc1."
     }
document { "ggreshape",
     TT "ggreshape", " -- gbengine command string.",
     PARA,
     "arguments: m:matrix F:freemodule G:freemodule >> matrix",
     PARA,
     "Yields the matrix obtained from 'm' of shape F <--- G, by taking elements from the first row of 'm', then the second, and so on, filling them into the result row by row.  Currently, it is assumed that 'm' and the result both have the same number of entries."
     }
document { "ggresmap",
     TT "ggresmap", " -- gbengine command string.",
     PARA,
     "arguments: gr:res_comp i:int >> matrix",
     PARA,
     "Return the i th matrix of the (minimal) resolution 'gr'."
     }
document { "ggresmodule",
     TT "ggresmodule", " -- gbengine command string.",
     PARA,
     "arguments: gr:res_comp i:int >> freemodule",
     PARA,
     "Return the i th free module of the (minimal) resolution 'gr'."
     }
document { "ggresNmap",
     TT "ggresNmap", " -- gbengine command string.",
     PARA,
     "arguments: gr:res_comp i:int >> matrix",
     PARA,
     "Return the i th matrix of the (possibly non-minimal) resolution 'gr'."
     }
document { "ggresNmodule",
     TT "ggresNmodule", " -- gbengine command string.",
     PARA,
     "arguments: gr:res_comp i:int >> freemodule",
     PARA,
     "Return the i th free module of the (possibly non-minimal) resolution 'gr'."
     }
document { "ggrightmult",
     TT "ggrightmult", " -- gbengine command string.",
     PARA,
     "arguments: v:EVector w:EVector >> EVector",
     PARA,
     "Return v*w, where the component is taken from v."
     }
document { "ggRow2by2",
     TT "ggRow2by2", " -- gbengine command string.",
     PARA,
     "arguments: a1:RingElement a2:RingElement b1:RingElement b2:RingElement m:SparseMutableMatrix r1:int r2:int >> .",
     PARA,
     "Modifies rows 'r1' and 'r2' of matrix 'm' as follows: row r1 is replaced with a1*(row r1)+a2*(row r2), and row r2 is replaced with b1*(row r1)+b2*(row r2).  The assignment to rows r1,r2 are performed simultaneously."
     }
document { "ggRowAddMultiple",
     TT "ggRowAddMultiple", " -- gbengine command string.",
     PARA,
     "arguments: m:SparseMutableMatrix r1:int a:RingElement r:int >> .",
     PARA,
     "Destructively set m[row r] = m[row r] + a * m[row r1].  Note: this is less efficient than the corresponding column operation."
     }
document { "ggRowInterchange",
     TT "ggRowInterchange", " -- gbengine command string.",
     PARA,
     "arguments: m:SparseMutableMatrix r1:int r2:int >> .",
     PARA,
     "Destructively interchange the two given rows of 'm'.  Note: this is less efficient than the corresponding column operation."
     }
document { "ggRowScale",
     TT "ggRowScale", " -- gbengine command string.",
     PARA,
     "arguments: m:SparseMutableMatrix r:int a:RingElement >> .",
     PARA,
     "Destructively set m[row r] = a * m[row r]. Note: this is less efficient than the corresponding column operation."
     }
document { "ggRR",
     TT "ggRR", " -- gbengine command string.",
     PARA,
     "arguments: . >> Ring",
     PARA,
     "Place the ring of real numbers (implemented as arithmetic on double precision floating point numbers) onto the stack."
     }
document { "ggsagbi",
     TT "ggsagbi", " -- gbengine command string.",
     PARA,
     "arguments: m:matrix >> sagbi_comp",
     PARA,
     "Creates a computation node for computing a sagbi basis of the subalgebra generated by the entries of the one row matrix m.  The usual gb_comp routines, such as ggcalc, gggetgb, etc. all work for this computation node."
     }
document { "ggsat",
     TT "ggsat", " -- gbengine command string.",
     PARA,
     "arguments: I:monideal m:monomial >> monideal;  OR  I:monideal J:monideal >> monideal;  OR m:monomial n:monomial >> monomial.",
     PARA,
     "Yields the saturation (I:m^*), or (I:J^*)."
     }
document { "ggschur",
     TT "ggschur", " -- gbengine command string.",
     PARA,
     "arguments: K:ring M:monoid >> R:ring",
     PARA,
     "Create the ring R = K[M], where each monomial is thought of as representing an irreducible GL(n)-module, where n is the number of variables of the monoid M.  Multiplication is the multiplication of schur functors, and is implemented using a variant of the Littlewood-Richardson rule."
     }
document { "ggsearch",
     TT "ggsearch", " -- gbengine command string.",
     PARA,
     "arguments: ti:TermIdeal m:Matrix >> Matrix",
     PARA,
     "This is a debug routine: given a matrix with one row, return a matrix with the same number of columns as 'm', each column being the result of applying 'search' to the lead term of that column of 'm'."
     }
document { "ggsee",
     TT "ggsee", " -- gbengine command string.",
     PARA,
     "arguments: string >> .",
     PARA,
     "Place this string onto the output stream."
     }
document { "ggselect",
     TT "ggselect", " -- gbengine command string.",
     PARA,
     "arguments: v:vector F:freemodule a:intarray >> vector",
     PARA,
     "Yields a vector w in F: w = v_(a_0) F_0 + ... v_(a_r-1) F_(r-1), where r is the length of 'a', which should be less than or equal to the rank of 'F'."
     }
document { "ggsend",
     TT "ggsend", " -- gbengine command string.",
     PARA,
     "arguments: remote_gb_comp >> .",
     PARA,
     "Send the generators to the remote machine. In development."
     }
document { "ggsetColChange",
     TT "ggsetColChange", " -- gbengine command string.",
     PARA,
     "arguments: m:SparseMutableMatrix n:SparseMutableMatrix >> .",
     PARA,
     "Set 'm' to record column operations in the matrix 'n'.  The matrix 'n' should have the same number of columns as 'm' has columns. (Thus, each time a column operation is performed on 'm', it is also performed on 'n'."
     }
document { "ggSetEntry",
     TT "ggSetEntry", " -- gbengine command string.",
     PARA,
     "arguments: m:SparseMutableMatrix r:int c:int a:RingElement >> .",
     PARA,
     "Set m[r,c] := a, assuming that the ring of 'a' is the same as the ring of 'm', and the indices are in range."
     }
document { "ggsetRowChange",
     TT "ggsetRowChange", " -- gbengine command string.",
     PARA,
     "arguments: m:SparseMutableMatrix n:SparseMutableMatrix >> .",
     PARA,
     "Set 'm' to record row operations in the matrix 'n'.  The matrix 'n' should have the same number of columns as 'm' has rows.  Thus, each time a row operation is performed on 'm', the corresponding column operation is performed on the matrix 'n'."
     }
document { "ggsetshift",
     TT "ggsetshift", " -- gbengine command string.",
     PARA,
     "arguments: m:matrix d:intarray >> .",
     PARA,
     "Set the degree of the map 'm' to be the degree 'd'.  The source and target free modules of the matrix are not changed (and so the result may no longer be graded)."
     }
document { "ggshift",
     TT "ggshift", " -- gbengine command string.",
     PARA,
     "arguments: F:freemodule a:intarray >> freemodule",
     PARA,
     "Return the graded free module F(a), where the length of a should be the number of degree vectors in the base ring of F."
     }
document { "ggsimplify",
     TT "ggsimplify", " -- gbengine command string.",
     PARA,
     "arguments: m:matrix n:int >> matrix",
     PARA,
     "Simplify the columns of the matrix 'm' in a way depending on the number 'n': if n=1, remove zero columns. if n=2, remove elements which are scalar multiples of others, and zeros, if n=3, remove columns which are divisible by other columns. Larger n will be possible as well: for example, one will be able to auto-reduce a set of columns, or remove monomial multiples, or replace with square-free elements."
     }
document { "ggskeleton",
     TT "ggskeleton", " -- gbengine command string.",
     PARA,
     "arguments: r:res_comp >> .",
     PARA,
     "Compute the skeleton of the resolution.  This is a debugging facility.  To see the number of pairs, use ggpairs after this, or grab the lead terms by using ggresNmap."
     }
document { "ggskewpolyring",
     TT "ggskewpolyring", " -- gbengine command string.",
     PARA,
     "arguments: K:ECoefficientRing M:EMonoid skews:intarray >> ESkewPolynomialRing",
     PARA,
     "Create the ring K[M], where multiplication is skew commutative for the variables in the 'skews' array.  All variables not in this list commute with all variables, whereas for variables x,y, in the list 'skews', x^2 = 0 and x*y = -y*x."
     }
document { "ggSmithNormalForm",
     TT "ggSmithNormalForm", " -- gbengine command string.",
     PARA,
     "arguments: m:matrix n:int >> SmithNormalFormComputation",
     PARA,
     "Create a computation to compute the Smith normal form for the matrix 'm'.  The base ring of 'm' should be a computable PID, e.g. ZZ or k[x], where k is a field.  If 'n' is non-zero, then enough information is collected to give the isomorphism matrix from the cokernel of the smith normal form matrix to the cokernel of 'm'.  As usual with computations, 'ggcalc' is used to perform the computation.  'gggetchange' gets the matrix representing this isomorphism (the change of basis matrix), assuming that the parameter 'n' is non-zero.  'gggetgb' returns the matrix whose cokernel is isomorphic to coker m.  If the computation is not complete, an intermediate value is returned.  Finally, 'ggstatus' returns an integer representing the current status of the computation.  (0 = computation is complete)."
     }
document { "ggsortcolumns",
     TT "ggsortcolumns", " -- gbengine command string.",
     PARA,
     "arguments: m:matrix degorder:int monorder:int>> intarray  OR m:SparseMutableMatrix lo:int hi:int >> intarray",
     PARA,
     "Return an integer array giving the permutation of columns required to sort the columns of 'm'. The order used is determined from the signs of degorder, monorder: if degorder is positive (negative), then the columns are sorted into ascending (descending) degree order.  If degorder is 0, or for columns having the same degree, if monorder is positive (negative), then these columns are sorted in ascending (descending) monomial order.  SECOND FORM: sort the columns lo..hi of 'm', and return the resulting permutation in the result, which is an array of length hi-lo+1.  The sort order used is: zero vectors are least, then the row of the lead term is considered (higher lead terms are sorted later), finally, if the coefficients are ZZ, the absolute value is considered, or, if this is a polynomial ring, the (simple) degree is considered, with larger values sorted later. (CURRENTLY: no intarray is returned: the sort is simply performed 6/30/98)."
     }
document { "ggsparsematrix",
     TT "ggsparsematrix", " -- gbengine command string.",
     PARA,
     "arguments: R:ring r:int c:int >> SparseMutableMatrix OR m:Matrix >> SparseMutableMatrix",
     PARA,
     "Create a so-called sparse matrix.  In the first case, the matrix is set to the zero r by c matrix over the ring R.  In the second case, the matrix is set to the matrix 'm', using a different representation.  This representation stores only non-zero components, and for each component, the entire ring element is stored as one element (this is different than the order required by the Groebner basis routines).  Routines that act on these SparseMutableMatrix's include: ggelem, ggset, ggRowInterchange, ggColumnInterchange, ggRowAddMultiple, ggColumnAddMultiple, ggRowScale, ggColumnScale."
     }
document { "ggsparsevector",
     TT "ggsparsevector", " -- gbengine command string.",
     PARA,
     "arguments: nothing yet",
     PARA,
     "nothing yet"
     }
document { "ggstack",
     TT "ggstack", " -- gbengine command string.",
     PARA,
     "arguments: . >> string",
     PARA,
     "Push a string containing the types of the stack elements."
     }
document { "ggstats",
     TT "ggstats", " -- gbengine command string.",
     PARA,
     "arguments: gb_comp >> .;  OR res_comp >> .",
     PARA,
     "Return a string describing the state of the Groebner or resolution computation, and the number of S-pair and generator computations remaining in each degree."
     }
document { "ggstatus",
     TT "ggstatus", " -- gbengine command string.",
     PARA,
     "arguments: SmithNormalFormComputation >> int OR ...",
     PARA,
     "Return an integer describing the state of the computation: 0 means the computation is done.  Any non-zero value means that the computation is not complete."
     }
document { "ggSTRING",
     TT "ggSTRING", " -- gbengine command string.",
     PARA,
     "arguments: (string from input) >> string",
     PARA,
     "Place a string on the stack."
     }
document { "ggsubduction",
     TT "ggsubduction", " -- gbengine command string.",
     PARA,
     "arguments: m:matrix F:ringmap J:GB >> matrix",
     PARA,
     "Given a (partial) SAGBI basis which is the image of the map F, and the GB J of the ideal (y_i - in(f_i)), computed in degrees at least as high as the elements of 'm', return the (auto) subduction of the one row matrix 'm'."
     }
document { "ggsubmatrix",
     TT "ggsubmatrix", " -- gbengine command string.",
     PARA,
     "arguments: rows:intarray cols:intarray M:matrix >> matrix",
     PARA,
     "Return the matrix obtained from M by choosing the given rows and columns in the specified order."
     }
document { "ggsubmodule",
     TT "ggsubmodule", " -- gbengine command string.",
     PARA,
     "arguments: F:freemodule rows:intarray >> freemodule",
     PARA,
     "Return the freemodule obtained by taking the basis elements of F given by rows[0], rows[1], ... rows[length(rows)-1]."
     }
document { "ggsubtract",
     TT "ggsubtract", " -- gbengine command string.",
     PARA,
     "arguments: a:var b:var >> var",
     PARA,
     "Place a-b onto the stack."
     }
document { "ggsymm",
     TT "ggsymm", " -- gbengine command string.",
     PARA,
     "arguments: F:freemodule d:int >> freemodule;  OR m:matrix d:int >> matrix",
     PARA,
     "Yields the d th symmetric power of the first argument.  Currently, the matrix argument must have only one row."
     }
document { "ggtensor",
     TT "ggtensor", " -- gbengine command string.",
     PARA,
     "arguments: matrix matrix >> matrix",
     PARA,
     "Return the tensor product ('outer' in Macaulay) of the two matrices."
     }
document { "ggterm",
     TT "ggterm", " -- gbengine command string.",
     PARA,
     "arguments: polyring a:ringelem m:monomial >> ringelem;  OR freemodule a:ringelem i:int >> vector",
     PARA,
     "Create a polynomial from a coefficient and a monomial (first case), or create a vector from a ring element and an integer component (second case)."
     }
document { "ggtermideal",
     TT "ggtermideal", " -- gbengine command string.",
     PARA,
     "arguments: m:matrix n:int >> termideal",
     PARA,
     "Given a matrix defined over a ring R = Z[x1..xn]/I, create the termideal of lead terms which occur in the 'i'th row of this matrix."
     }
document { "ggtest",
     TT "ggtest", " -- gbengine command string.",
     PARA,
     "arguments: . >> .",
     PARA,
     "Run some debugging code.  Internal use only."
     }
document { "ggtonet",
     TT "ggtonet", " -- gbengine command string.",
     PARA,
     "arguments: var >> string",
     PARA,
     "Place onto the stack a string representation of var suitable for dumping to a disk or network (using the command netsee)."
     }
document { "ggtostring",
     TT "ggtostring", " -- gbengine command string.",
     PARA,
     "arguments: var >> string",
     PARA,
     "Place a reasonably readable string representation of the object onto the stack."
     }
document { "ggtracing",
     TT "ggtracing", " -- gbengine command string.",
     PARA,
     "arguments: int >> int",
     PARA,
     "Set the amount of tracing output done by GB routines (0 = none), and return on the stack the current tracing value."
     }
document { "ggtranspose",
     TT "ggtranspose", " -- gbengine command string.",
     PARA,
     "arguments: matrix >> matrix",
     PARA,
     "Return the (graded) transpose of the given matrix."
     }
document { "ggtruncate",
     TT "ggtruncate", " -- gbengine command string.",
     PARA,
     "arguments: to do",
     PARA,
     "to do"
     }
document { "ggisunit",
     TT "ggisunit", " -- gbengine command string.",
     PARA,
     "arguments: f:ringelem >> int",
     PARA,
     "If f is a unit, place 1 on the stack, else place a 0."
     }
document { "ggvar",
     TT "ggvar", " -- gbengine command string.",
     PARA,
     "arguments: xring v:int e:int >> ringelem",
     PARA,
     "Place the monomial x^e onto the stack, where x is the v th variable in the given ring."
     }
document { "ggvector",
     TT "ggvector", " -- gbengine command string.",
     PARA,
     "arguments: vecinfo f0:ringelem f2:ringelem ... f(r-1):ringelem >> vector",
     PARA,
     "Create the vector f0 <0> + f1 <1> + ... + f(r-1) <r-1> using 'vecinfo'."
     }
document { "ggweylalgebra",
     TT "ggweylalgebra", " -- gbengine command string.",
     PARA,
     "arguments: k:field M:monoid a:intarray >> ring",
     PARA,
     "Create the ring of differential operators (the Weyl algebra), whose underlying commutative polynomial ring is k[M], and where the differential operators are given by 'a'. (E.g. a = {0,2,1,3} associates variable 2 to be the differential operator corresponding to the variable 0, var 3 is the diff op corresponding to var 1, etc.  A negative value signifies that the corresponding diff op, or commutative variable, is not present."
     }
document { "ggGF",
     TT "ggGF", " -- gbengine command string.",
     PARA,
     "arguments: p:int n:int >> ring",
     PARA,
     "Create the finite field having p^n elements, where p is a prime number."
     }
document { "ggZ",
     TT "ggZ", " -- gbengine command string.",
     PARA,
     "arguments: . >> ring",
     PARA,
     "Place the ring of integers onto the stack."
     }
document { "ggZn",
     TT "ggZn", " -- gbengine command string.",
     PARA,
     "arguments: n:int >> monoid",
     PARA,
     "Yields the monoid Z^n, where each entry must fit into a machine integer."
     }
document { "ggzero",
     TT "ggzero", " -- gbengine command string.",
     PARA,
     "arguments: F:freemodule >> vector",
     PARA,
     "Yields the zero vector of F."
     }
document { "ggzeromat",
     TT "ggzeromat", " -- gbengine command string.",
     PARA,
     "arguments: rows:freemodule cols:freemodule >> matrix",
     PARA,
     "Place the zero matrix cols --> rows onto the stack.  "
     }
document { "ggzeromonoid",
     TT "ggzeromonoid", " -- gbengine command string.",
     PARA,
     "arguments: . >> monoid",
     PARA,
     "Returns the trivial monoid with a single element."
     }
